using System;
using System.Data.SqlTypes;
using System.IO;
using System.Text;
using System.Diagnostics;
using Bibliotecas.Model;

public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void stpCompacta_Arquivo(SqlString caminho, SqlString filtro, SqlString arquivoCompactado, SqlInt32 nivelCompactacao, SqlString senha)
    {


        string[] arquivos;

        #region tratamento de entradas

        if (nivelCompactacao.Value < 0 || nivelCompactacao.Value > 9)
        {
            Retorno.Erro("Parametro invlido na variavel nivelCompactacao, use de 0 a 9 para compactar, sendo 9 o nivel mais alto (5 recomendado).");
            return;
        }


        try
        {
            if (!Directory.Exists(caminho.Value))
            {
                Retorno.Erro($"O caminho especificado '{arquivoCompactado}' no existe ou est inacessivel.");
                return;
            }
        }
        catch
        {
            Retorno.Erro($"Erro ao converter caminho especificado ('{arquivoCompactado}').");
            return;
        }


        try
        {
            arquivos = Directory.GetFiles(caminho.Value, filtro.Value);
        }
        catch
        {
            Retorno.Erro($"Erro ao listar arquivos no caminho especificado ({arquivoCompactado}).");
            return;
        }


        var objetoArquivoCompactado = new FileInfo(arquivoCompactado.Value);
        var diretorioArquivoCompactado = objetoArquivoCompactado.Directory?.ToString();

        if (diretorioArquivoCompactado == null || !Directory.Exists(diretorioArquivoCompactado))
        {
            Retorno.Erro($"O caminho do arquivo compactado especificado ({diretorioArquivoCompactado}) no existe ou inacessvel.");
            return;
        }


        if (objetoArquivoCompactado.Extension.Trim() != "")
        {
            try
            {
                objetoArquivoCompactado.Delete();
            }
            catch
            {
                Retorno.Erro($"o arquivo compactado especificado ({arquivoCompactado.Value}) est sendo usado.");
                return;
            }
        }
        else
        {
            Retorno.Erro($"O arquivo compactado especificado no possui uma extenso vlida ({objetoArquivoCompactado.Extension.Trim()}).");
            return;
        }



        #endregion

        try
        {

            var argumentos = $@" a -tzip -mx{nivelCompactacao.Value} ""{arquivoCompactado.Value}""" + (!senha.IsNull && !string.IsNullOrEmpty(senha.Value) ? $" -p{senha.Value} " : " ") + $@"""{caminho.Value}\{filtro.Value}"" -mmt";

            using (var scriptProc = new Process { StartInfo = { FileName = @"C:\Binn\7za.exe", UseShellExecute = false, Arguments = argumentos, RedirectStandardOutput = true, RedirectStandardError = true, StandardOutputEncoding = Encoding.GetEncoding(850), StandardErrorEncoding = Encoding.GetEncoding(850), CreateNoWindow = true } })
            {

                scriptProc.Start();

                var output = scriptProc.StandardOutput.ReadToEnd();
                var erro = scriptProc.StandardError.ReadToEnd();


                if (output.Length > 0)
                {
                    //Retorno.Mensagem(output);
                }


                if (erro.Length > 0)
                {
                    Retorno.Erro(erro);
                }

            }

            var quantidadeArquivos = arquivos.Length;

            Retorno.Mensagem("Total de: (" + quantidadeArquivos + ") arquivos foram compactados em: " + arquivoCompactado.Value);
        }
        catch (Exception e)
        {
            Retorno.Erro("Erro : " + e.Message);
        }
    }

};
