using System;
using System.Data.SqlTypes;
using System.Diagnostics;
using System.IO;
using System.Text;
using Bibliotecas.Model;


public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void stpDescompacta_Arquivo(SqlString arquivoCompactado, SqlString pastaDestino, SqlString filtro, SqlString senha)
    {


        #region tratamento de entradas

        var ArquivoCompactado = new FileInfo(arquivoCompactado.Value);
        if (ArquivoCompactado.Directory == null || !Directory.Exists(ArquivoCompactado.Directory.ToString()))
        {
            Retorno.Erro($"O caminho do arquivo compactado especificado ({ArquivoCompactado.Directory}) no existe ou inacessvel.");
            return;
        }

        if (!ArquivoCompactado.Exists)
        {
            Retorno.Erro($"O arquivo compactado '{arquivoCompactado.Value}' no existe.");
            return;
        }

        #endregion

        try
        {

            var argumentos = $@" x ""{arquivoCompactado.Value}"" -aoa -o""{pastaDestino.Value}"" {filtro.Value} " + (!senha.IsNull && !string.IsNullOrEmpty(senha.Value) ? $" -p{senha.Value} " : "") + "-r -mmt";

            using (var scriptProc = new Process { StartInfo = { FileName = @"C:\Binn\7za.exe", UseShellExecute = false, Arguments = argumentos, RedirectStandardOutput = true, RedirectStandardError = true, StandardOutputEncoding = Encoding.GetEncoding(850), StandardErrorEncoding = Encoding.GetEncoding(850), CreateNoWindow = true } })
            {

                scriptProc.Start();
                
                var output = scriptProc.StandardOutput.ReadToEnd();
                var erro = scriptProc.StandardError.ReadToEnd();


                if (output.Length > 0)
                {
                    Retorno.Mensagem(output);
                }


                if (erro.Length > 0)
                {
                    Retorno.Erro(erro);
                }


            }

            Retorno.Mensagem("Os arquivos foram descompactados em: " + pastaDestino.Value);

        }
        catch (Exception e)
        {
            Retorno.Erro("Erro : " + e.Message);
        }
    }
};
